

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <malloc.h>
#include <libgen.h>
#include <unistd.h>
#include <fnmatch.h>

#define SIZED 256
extern char* name;
extern char* path;
extern char* exec;
extern char* cmalloc(size_t size);
void
checkname(char* ppath,int* isadd) {
    char* bsname=basename(ppath);
    if (name!=NULL) {
        int ch=fnmatch(name,bsname,0);
        if (ch==FNM_NOMATCH) {
            *isadd=0;
        } else if (ch!=0) {
            fprintf(stderr,"wrong pattern");
            exit(1);
        };
    };

};



int
conform_checkint(char* ppath) {

    //проверка на включение
    int isadd=1;
    checkname(ppath,&isadd);
    return isadd;
};
void
openderr(int sterr) {

    fprintf(stderr,"не удалось открыть каталог : %s\n",strerror(sterr));
    /*
     switch (sterr) {
    	 case	ENOENT:;
    	 break;
    	 case	EMFILE:;
    	 break;
    	 case	ENFILE :;
    	 break;
    	 case	ENOTDIR:;
    	 break;
    	 case	EACCES:;
    	 break;
    	 case	ENOMEM:;
    	 break;
     }
     */
};
void
staterror(int sterr) {

    fprintf(stderr,"не удалось получить stat : %s\n",strerror(sterr));
    /*
     switch (sterr) {
    	 case	ENOENT:;
    	 break;
    	 case	ENOTDIR:;
    	 break;
    	 case	ELOOP:;
    	 break;
    	 case	EFAULT:;
    	 break;
    	 case	EACCES:;
    	 break;
    	 case	ENOMEM:;
    	 break;
    	 case	ENAMETOOLONG:;
    	 break;
     }
     */
};
int fullpath;
void
mreaddir( char *ppath) {
    DIR* dir;
    struct stat pst;

    if (lstat(ppath,&pst)==-1) {
        staterror(errno);
    } else {
        if (conform_checkint(ppath)) {

            if (fullpath)
                printf("%s\n",ppath);
            else
                printf(".%s\n",ppath+strlen(path));
        };

        if (S_ISDIR(pst.st_mode)) {
            if ((dir=opendir(ppath))==NULL) {
                openderr(errno);
            } else {
                struct dirent *currfile;
                char * fullname;
                while ((currfile=readdir(dir))!=NULL) {
                    fullname=NULL;
                    struct stat st;
                    fullname=cmalloc(strlen(currfile->d_name)+strlen(ppath)+2);
                    if (currfile->d_name[0]!='/')
                        sprintf(fullname, "%s/%s",ppath,currfile->d_name);
                    else
                        sprintf(fullname, "%s%s",ppath,currfile->d_name);
                    if (lstat(fullname,&st)==-1) {
                        staterror(errno);
                    } else {
                        if (
                            (strcoll(currfile->d_name,".") &&
                             strcoll(currfile->d_name,"..")
                            )
                        ) {
                            mreaddir(fullname);
                        };

                    };
                    free(fullname);
                };
            };
        };

    };
};

char*
cmalloc(size_t size) {
    char* tmp;
    tmp=NULL;
    tmp=(char* )malloc((size_t) sizeof(tmp)*size);
    if (tmp==NULL) {
        fprintf(stderr,"Failed to allocate memory : %s \n",strerror(errno));
        exit(1);
    }
    memset(tmp,0,size*sizeof(tmp));
    return tmp;
};
char*
mstrcpy(char* instr) {
    char* outstr=NULL;
    outstr=cmalloc(strlen(instr)+1);
    if (strcpy(outstr,instr)==NULL) {
        fprintf(stderr,"Error copying rows : %s \n",strerror(errno));
        exit(1);
    };
    return outstr;
};
char*
mgetcwd() {
    char* outstr=NULL;
    outstr=cmalloc((size_t)SIZED);
    if (getcwd(outstr,SIZED)==NULL) {
        fprintf(stderr,"Could not get current directory : %s \n",strerror(errno));
        exit(1);
    };
    if (strlen(outstr)<SIZED) {
        char *tmp=realloc(outstr,strlen(outstr)+1);
        if (tmp==NULL) {
            fprintf(stderr,"Failed to allocate memory : %s \n",strerror(errno));
            exit(1);
        };
        outstr=tmp;
    };

    return outstr;
};


char* name;
char* path;
char* exec;

int
main(int argc,char** argv) {
    int pend=0;
    char* tmp=NULL;
    if (argc>1)	{
        int i=1;
        while (i<argc) {
            if (argv[i]!=NULL) {
                if (!strcoll(argv[i],"-name")) {
                    pend=1;
                    if (argv[i+1]!=NULL && argv[i+1][0]!='-') {

                        name=mstrcpy(argv[i+1]);
                        i++;
                    } else {
                        fprintf(stderr,"-name : missing  parameter  \n");
                        exit(1);
                    };
                } else if (!strcoll(argv[i],"-exec")) {
                    pend=1;
                    if (argv[i+1]!=NULL && argv[i+1][0]!='-') {
                        exec=mstrcpy(argv[i+1]);
                        i++;
                    } else {
                        fprintf(stderr,"-exec : missing  parameter  \n");
                        exit(1);
                    };
                } else {

                    switch (argv[i][0]) {
                    case '/':
                        if (!pend) {
                            fullpath=1;
                            path=mstrcpy(argv[i]);
                            pend=1;
                        } else {
                            fprintf(stderr,"indicated more than one path\n");
                            exit(1);
                        };
                        break;
                    case '-':
                        fprintf(stderr,"wrong option\n");
                        exit(1);
                        break;
                    default:
                        if (!pend) {

                            tmp=mgetcwd();
                            path=cmalloc((size_t)strlen(tmp)+strlen(argv[i])+1);
                            pend=1;
                            if (tmp[strlen(tmp)]!='/')
                                sprintf(path, "%s/%s",tmp,argv[i]);
                            else
                                sprintf(path, "%s%s",tmp,argv[i]);
                        } else {
                            fprintf(stderr,"indicated more than one path\n");
                            exit(1);
                        }
                        ;
                        break;

                    };
                };
            };
            i++;
        };
    } else {
        path=mgetcwd();
    };
    if (path==NULL && pend) {
        path=mgetcwd();
    };
    if (path!=NULL)	{
        mreaddir(path);
    };
    //	printf("%s\n",name);
    return (0);
};

